from ast import AST
from typing import NoReturn


type region = tuple[int, int, int | None, int | None]


def to_string(r: region) -> str:
    match r:
        case [l1, c1, None, _] | [l1, c1, _, None]:
            return str(l1) + ":" + str(c1 + 1)
        case [l1, c1, l2, c2]:
            return str(l1) + ":" + str(c1 + 1) + "-" + str(l2) + ":" + str(c2 + 1)


def fail(n: AST, err: Exception) -> NoReturn:
    r: region = (n.lineno, n.col_offset, n.end_lineno, n.end_col_offset)
    print("Error at " + to_string(r) + ":")
    print("  " + type(err).__name__ + ": " + str(err))
    exit(1)
